Summary: Leading World Wide Web server
Name: apache
%define apache_ver 1.3.6
%define php_ver 3.0.7
%define mcz_ver 3.1.0b4
%define mcz_pkg mcz_1.3.4_3.1.0b4
Version: %{apache_ver}
Release: 1cz
Group: Networking/Daemons

Source: ftp://ftp.apache.org/apache/dist/apache_%{apache_ver}.tar.gz
Source1: apache.log
Source2: apache-httpd.conf
Source3: ftp://ftp.php.net/pub/distributions/php-%{php_ver}.tar.gz
Source4: http://www.intersoft.cz/mod_czech/download/mod_czech3/Version_3_1_0b/Apache_1_3_4_Version/%{mcz_pkg}.tgz

Patch1: apache_1.3.4-apxs.patch
Patch2: apache_1.3.4-srvroot.patch
Patch3: apache_1.3.4-apachectl.patch
# Needed for glibc-2.1
#Patch4: apache_%{apache_ver}-ndbm.patch
# mod_czech stuff
Patch5: mcz-patch_%{apache_ver}_%{mcz_ver}.gz
Patch6: mcz-mvfix.patch
Patch7: php-%{php_ver}-nodebug.patch

Copyright: Freely distributable and usable
BuildRoot: /var/tmp/apache-root
Prereq: /sbin/chkconfig, /bin/mktemp
Provides: webserver

%description
Apache is a full featured web server that is freely available, and also
happens to be the most widely used.

%package devel
Group: Networking/Daemons
Summary: Header files from apache for developing/compiling 3rd party modules
Obsoletes: secureweb-devel

%description devel
This package includes the required Apache-1.3.4 source files, as well as the
'apxs' script for building dynamic shared objects (DSOs).  This package needs
to be installed if you want to compile or develop additional modules for
Apache.

%prep
# unpack Apache
%setup -q -n apache_%{apache_ver}
%patch1 -p1 -b .apxs
%patch2 -p1 -b .srvroot
%patch3 -p1 -b .apachectl
# Needed for glibc-2.1
#%patch4 -p1 -b .ndbm

# mod_czech patches
cd src
%patch5 -p1 -b .mcz
cd ..
%patch6 -p1 -b .mcz-mvfix
# mod_czech package with docs
%setup -T -q -b 4 -n %{mcz_pkg}

# unpack PHP files
%setup -T -q -b 3 -n php-%{php_ver}
%patch7 -p1 -b .nodebug

%build
# we have to initialize PHP stuff and move them to Apache tree first
cd ../apache_%{apache_ver}

# we need to run configure before anything else
OPTIM="$RPM_OPT_FLAGS" \
        ./configure --prefix=/usr

cd ../php-%{php_ver}
OPTIM="$RPM_OPT_FLAGS" \
        ./configure --with-pgsql=/usr \
        --with-apache=../apache_%{apache_ver} \
	--with-config-file-path=/etc/httpd/conf \
        --enable-track-vars
make
make install

cd ../apache_%{apache_ver}
OPTIM="$RPM_OPT_FLAGS" \
        ./configure --prefix=/usr  \
        --libexecdir=/usr/lib/apache \
        --sysconfdir=/etc/httpd/conf \
        --serverroot=/etc/httpd \
        --datadir=/home/httpd \
        --bindir=/usr/bin \
        --sbindir=/usr/sbin \
        --includedir=/usr/include/apache \
        --logfiledir=/var/log/httpd \
        --localstatedir=/var \
        --runtimedir=/var/run \
        --proxycachedir=/var/cache/httpd \
        --activate-module=src/modules/czech/libczech.a \
        --activate-module=src/modules/php3/libphp3.a \
	--enable-module=mime_magic \
	--enable-module=speling \
	--enable-module=info \
	--enable-module=rewrite \
	--enable-suexec \
	--suexec-caller=nobody \
	--suexec-userdir=html
make
strip $RPM_BUILD_DIR/apache_%{apache_ver}/src/httpd
	
%install
cd $RPM_BUILD_DIR/apache_%{apache_ver}
rm -rf $RPM_BUILD_ROOT
make install root=$RPM_BUILD_ROOT

# install apachectl as our SYSV init script
mkdir -p $RPM_BUILD_ROOT/etc/rc.d/init.d
install -m755 $RPM_BUILD_ROOT/usr/sbin/apachectl \
	$RPM_BUILD_ROOT/etc/rc.d/init.d/httpd

# install log rotation stuff
mkdir -p $RPM_BUILD_ROOT/etc/logrotate.d
install -m644 $RPM_SOURCE_DIR/apache.log \
	$RPM_BUILD_ROOT/etc/logrotate.d/apache

ln -s ../../var/log/httpd $RPM_BUILD_ROOT/etc/httpd/logs
ln -s ../../usr/lib/apache $RPM_BUILD_ROOT/etc/httpd/modules
ln -s ../../usr/lib $RPM_BUILD_ROOT/etc/httpd/lib

# replace Apache's default config file
install -m644 $RPM_SOURCE_DIR/apache-httpd.conf \
	$RPM_BUILD_ROOT/etc/httpd/conf/httpd.conf

# install Apache source code for devel package
#mkdir -p $RPM_BUILD_ROOT/usr/src
#tar xzf $RPM_SOURCE_DIR/apache_%{apache_ver}.tar.gz -C $RPM_BUILD_ROOT/usr/src
find $RPM_BUILD_ROOT -type f | \
	xargs grep -l "/usr/local/bin/perl" | \
	xargs perl -pi -e "s|/usr/local/bin/perl|/usr/bin/perl|g;"

# install mcz docs & cfg
install -m644 $RPM_BUILD_DIR/%{mcz_pkg}/mcz_config \
        $RPM_BUILD_ROOT/etc/httpd/conf/czech.conf
install -d $RPM_BUILD_ROOT/usr/doc/mcz-%{mcz_ver}
install -d $RPM_BUILD_ROOT/usr/doc/mcz-%{mcz_ver}/doc
install -m644 $RPM_BUILD_DIR/%{mcz_pkg}/[CIRT]* \
        $RPM_BUILD_ROOT/usr/doc/mcz-%{mcz_ver}
install -m644 $RPM_BUILD_DIR/%{mcz_pkg}/doc/* \
        $RPM_BUILD_ROOT/usr/doc/mcz-%{mcz_ver}/doc
install -d $RPM_BUILD_ROOT/home/httpd/mod_czech
install -m644 $RPM_BUILD_DIR/%{mcz_pkg}/pictures/* \
        $RPM_BUILD_ROOT/home/httpd/mod_czech

# PHP config file
install -m644 $RPM_BUILD_DIR/php-%{php_ver}/php3.ini-dist \
        $RPM_BUILD_ROOT/etc/httpd/conf/php3.ini

%clean
#rm -rf $RPM_BUILD_ROOT

%post
/sbin/chkconfig --add httpd

%preun
if [ $1 = 0 ]; then
   /sbin/chkconfig --del httpd
fi

%files
%defattr(-,root,root)
%dir /etc/httpd/conf
%config /etc/httpd/conf/access.conf
%config /etc/httpd/conf/srm.conf
%config /etc/httpd/conf/httpd.conf
%config /etc/httpd/conf/magic
%config /etc/httpd/conf/mime.types
%config /etc/httpd/conf/php3.ini
%config /etc/httpd/conf/czech.conf

/etc/httpd/logs
/etc/httpd/modules
/etc/httpd/lib
%config /etc/logrotate.d/apache
%config /etc/rc.d/init.d/httpd

%dir /home/httpd
%dir /home/httpd/cgi-bin
%dir /home/httpd/htdocs
%config(noreplace) /home/httpd/htdocs/index.html
%doc /home/httpd/htdocs/apache_pb.gif
%doc /home/httpd/htdocs/manual
/home/httpd/icons
/home/httpd/mod_czech

/usr/lib/apache
%doc /usr/man/man8/ab.8
%doc /usr/man/man8/apachectl.8
%doc /usr/man/man1/dbmmanage.1
%doc /usr/man/man1/htdigest.1
%doc /usr/man/man1/htpasswd.1
%doc /usr/man/man8/apxs.8
%doc /usr/man/man8/httpd.8
%doc /usr/man/man8/logresolve.8
%doc /usr/man/man8/rotatelogs.8
/usr/bin/dbmmanage
/usr/bin/htdigest
/usr/bin/htpasswd
/usr/sbin/ab
/usr/sbin/httpd
/usr/sbin/logresolve
/usr/sbin/rotatelogs
%attr(4711,root,root) /usr/sbin/suexec

%doc /usr/doc/mcz-%{mcz_ver}

%attr(-,nobody,nobody) %dir /var/cache/httpd
%dir /var/log/httpd

%files devel
%defattr(-,root,root)
/usr/include/apache
/usr/sbin/apxs
%doc /usr/man/man8/apxs.8
#/usr/src/apache_%{apache_ver}

%changelog
* Tue Apr  6 1999 Milan Kerslager <milan.kerslager>
- heavily modified to fit with PHP & mod_czech
- czech patch for PHP
- a lot of garbage deleted

* Thu Mar 11 1999 Rasmus Lerdorf <rasmus@apache.org>
- Get rid of the hsregex disable switch
- add ndbm patch to make mod_rewrite module find ndbm.h on glibc-2.1 systems
